/*global $, alert, console, Modernizr*/
/*jslint plusplus: true */

// (╯°□°）╯︵ ┻━┻

var formify = (function () {
	'use strict';
	return {

		init: function () {
			formify.detects.init();
			formify.forms.init();
		},

		detects: (function () {
			return {
				init: function () {
					if ((navigator.appVersion.indexOf("Win")!=-1) && (navigator.userAgent.indexOf("Firefox"))!=-1) {
						$('html').addClass('winff');
					}
//					alert('Pointer : ' + Modernizr.pointerevents + ' - touch : ' + Modernizr.touchevents);
//					console.log('Pointer : ' + Modernizr.pointerevents + ' - touch : ' + Modernizr.touchevents);
				}
			};
		}()),

		forms: (function () {
			return {
				init: function () {
					formify.forms.formatForm($('.formify'));
					/*formify.forms.enrichCheckboxes();*/
				},

/*				enrichCheckboxes: function () {
					$('.formify_checkbox').each(function () {
						var cont = $(this).eq(0),
							isRequired = cont.find('[required=true]').length > 0,
							elem = cont.find('input').eq(0);
							
						elem.find('input').change(function () {
							if (this.checked) {
								elem.addClass('formify_checkbox_square');
								if (elem.hasClass('formify_checkbox_circle')) {
									elem.siblings().removeClass('formify_checkbox_square');
								}
							} else {
								elem.removeClass('formify_checkbox_square');
							}
							
							console.log("chk");
							formify.forms.handleValidity(cont, isRequired, false);
						});
					});
				},*/

				handleForm: function (form) {
					var ret = 0;
					form.find('.formify_textinput, .formify_checkbox').each(function () {
						var cont = $(this).eq(0),
							isRequired = cont.find('[required=true]').length > 0;

						if (!formify.forms.handleValidity(cont, isRequired, false)) {
							ret++;
							var el = cont.find('input, textarea').eq(0);
						}
					});
					return(ret);
				},

				formatForm: function (form) {
					form.addClass('frmtd');
					
					form.find('form').attr('novalidate', '');
					
					form.find('.formify_checkbox').each(function () {
						var cont = $(this).eq(0),
							isRequired = cont.find('[required=true]').length > 0,
							elem = cont.find('input').eq(0);
						
						elem.on('change', function () {
							formify.forms.handleValidity(cont, isRequired, false);
							//console.log(elem.attr('type'));
							if (elem.attr('type') == 'radio') cont.siblings().each(function() {
								var cont = $(this).eq(0),
									isRequired = cont.find('[required=true]').length > 0;
		
								formify.forms.handleValidity(cont, isRequired, false);
							});
						});
					});
					
					form.find('.formify_textinput').each(function () {
						var cont = $(this).eq(0),
							label = cont.find('label'),
							pht = label.text(),
							info = "facultatif",
							isRequired = cont.find('[required=true]').length > 0,
							elem = cont.find('input, select, textarea').eq(0),
							id,
							optgroup,
							toggleOptgroup = function() {};


						if (elem.is('#email_footer')) {
							info = "";
						}

						/* construction du select */
						if (elem.is('select')) {
							id = elem.attr('id');
							name = elem.attr('name');

							/* On remplace le select par un input text */
							cont.addClass('fake_select');
							elem.attr('id', 'removed_' + id);
							elem.attr('name', 'removed_' + name);
							cont.append('<input type="text" readonly id="' + id + '" name="' + name + '" /><div class="optgroup"></div>');
							optgroup = cont.find('.optgroup');

							/* construction du groupe d'option */
							elem.find('option').each(function () {
								optgroup.append('<div class="option" data-value="' + $(this).attr('value') + '">' + $(this).text() + '&nbsp;</div>');
							});

							/* reattribution de la variable 'elem' à l'input (et pas au select) */
							elem = cont.find('input');

							/* function d'ouverture / fermeture du deroulant */
							toggleOptgroup = function (st) {
								if (st === 'open') {
									optgroup.addClass('opened');
									$('.shield').addClass('active');
								} else {
									optgroup.removeClass('opened');
									$('.shield').removeClass('active');

									// on verifie le champ à chaque fermeture
									formify.forms.handleEmptyness(cont);
									formify.forms.handleValidity(cont, isRequired);
								}
							};

							/* bind des options */
							cont.find('.option').on('click', function () {
								$(this).addClass('selected').siblings().removeClass('selected');
								elem.val($(this).data("value"));

								if (!cont.hasClass('no-verif')) {
									formify.forms.handleValidity(cont, isRequired, false);
								}
								toggleOptgroup('close');

							});
							/* bind du shield */
							$('.shield').on('click', function () {
								toggleOptgroup('close');
							});

						}


						/* Ajout de l'info */
						if (isRequired) {
							info = "* obligatoire";
						}
						if (!cont.hasClass('no-note')) {
							cont.append('<span class="info infofirsttime">' + info + '</span>');
						}

						/* Création du placeholder en fonction du label */
						elem.attr('placeholder', pht);


						/* reset de l'état de l'element lors du focus */
						elem.on('focus', function () {
							$(this).parent().removeClass('valid invalid');
							$(this).parent().find('.info').html(info);

							/* ouverture du menu deroulant le cas echeant */
							if (cont.hasClass('fake_select')) {
								toggleOptgroup('open');
							}
						});

						/* Gestion de l'affichage du label ou placehoder (rempli/vide) */
						elem.on('input', function () {
							formify.forms.handleEmptyness(cont);
						});
						formify.forms.handleEmptyness(cont);
						

						/* verification de l'élément lors de la sortie du champs */
						if ((!cont.hasClass('no-verif')) ) {
							elem.on('blur', function () {
								/*if (cont.hasClass('fake_select')) {
									toggleOptgroup('close');
								}*/
								formify.forms.handleValidity(cont, isRequired, false);
								/* fermeture du menu deroulant le cas echeant */
							});
							formify.forms.handleValidity(cont, isRequired, true);
						}
					});

					setTimeout(function () {
						form.addClass('attachanimations');
					}, 200);
				},

				formatField: function (el, type) {
					if (type === 'iban') {
						var val = el.val(),
							refVal = val.replace(/ /g, ''),
							i,
							newVal,
							selS = el[0].selectionStart,
							selE = el[0].selectionEnd;
						newVal = refVal.substr(0, 4);
						for (i = 4; i < refVal.length; i += 4) {
							newVal += ' ' + refVal.substr(i, 4);
						}
						newVal = newVal.substr(0, 33);

						selS += Math.floor(selS / 4);
						selE += Math.floor(selE / 4);
						el.val(newVal);
						el[0].setSelectionRange(selS, selE);
					}
				},

				checkValidity: function (el) {
					var type = el.attr('type'),
						id = el.attr('id'),
						val = el.val(),
						valIs2orMore = val.length > 1,
						pattern,

						isIt = function (what) {
							switch (what) {
							case 'moreThan2Chars':
								return valIs2orMore;
							case 'anEmail':
								pattern = /^([a-zA-Z0-9_.+\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
								break;
							case 'aNumber':
								val = val.replace(/\.|,| /g, '');
								pattern = /^[0-9]+$/;
								break;
							case 'aTel':
								val = val.replace(/\.|,| |\/|\-|:|;/g, '');
								pattern = /^[0-9]{10}$/;
								break;
							case 'aPostcode':
								val = val.replace(/\.|,| /g, '');
								pattern = /^[0-9]{5}$/;
								break;
							case 'anIban':
								val = val.replace(/\.|,| /g, '');
								return val.length === 27;
							}
							el.val(val);
							return pattern.test(val);
						};



					if (el.is('textarea')) {
						return isIt('moreThan2Chars');
					} else {

						/* On verifie prioritairement via les id */
						switch (id) {
						//
						case 'email':
							return isIt('anEmail');
						case 'postcode':
							return isIt('aPostcode');
						case 'bic':
							return isIt('aNumber');
						case 'iban':
							return isIt('anIban');

						default:
							/* puis via les type */
							switch (type) {
							//
							case 'radio':
								var elname = el.attr('name');
								return $('[name='+elname+']').is(':checked');
							case 'checkbox':
								return el.is(':checked');
							case 'email':
								return isIt('anEmail');
							case 'number':
								return isIt('aNumber');
							case 'tel':
								return isIt('aTel');
							default:
								return isIt('moreThan2Chars');
							}
						}
					}

				},

				handleEmptyness: function (el) {
					var input = el.find('input, textarea');
					if (input.val()) {
						el.addClass('not_empty');
					} else {
						el.removeClass('not_empty');
					}
				},

				handleValidity: function (el, isRequired, noPressure) {
					var input = el.find('input, textarea').eq(0),
						info = el.find('.info'),
						type = input.attr('type');
					if (
						( (type!="checkbox") && (!input.val()) && (!noPressure) )
						||
						( (type=="checkbox") && (!input.is(":checked")) && (!noPressure) )
					) {
					//console.log(type);
						if (isRequired) {
							el.addClass('invalid').removeClass('valid');
							info.removeClass('infofirsttime');
							return(false);
						} else {
//							el.addClass('valid').removeClass('invalid');
							el.removeClass('invalid valid');
							info.removeClass('infofirsttime');
							return(true);
						}
					} else {
						if (formify.forms.checkValidity(input)) {
							el.addClass('valid').removeClass('invalid');
							info.removeClass('infofirsttime');
							info.html('ok');
							return(true);
						} else {
							if (!noPressure) {
								el.addClass('invalid').removeClass('valid');
								info.removeClass('infofirsttime');
								info.html('non valide');
								return(false);
							}
						}
					}
				}

			};
		}())
	};
}());

$(document).ready(formify.init);
